Экран авторизации с вводом пароля {#sec.autorise.part2}
-------------------------------------------------------

Если авторизация по введенному в предыдущем экране логину и 
адресу уже проводилась, то экран с вводом пароля отображает 
следующую информацию.

![Авторизация, ввод пароля](resources/img/autorise/authorization2.png)

**Элементы управления экрана.**

+---------------------------+---------------------------+------------------------------------------------+
| Элемент управления        | Расположение на экране    | Описание                                       |
+===========================+===========================+================================================+
| ARTA                      | Верхняя половина          | Лейбл, обозначающий наименование системы       |
+---------------------------+---------------------------+------------------------------------------------+
| synergy.company.com       | Под наименованием системы | Лейбл, обозначающий адрес приложения           |
+---------------------------+---------------------------+------------------------------------------------+
| Фото в круглой рамке      | По центру экрана          | Фотография пользователя                        |
+---------------------------+---------------------------+------------------------------------------------+
| Абдрешен Леонид           | Под фотографией           | Лейбл, обозначающий Фамилию и Имя пользователя |
+---------------------------+---------------------------+------------------------------------------------+
| l.abdreshen               | Ниже адреса               | Лейбл, обозначающий логин пользователя         |
+---------------------------+---------------------------+------------------------------------------------+
| Пароль                    | Ниже адреса               | Содержит лейбл "Логин" и поле для ввода        |
|                           |                           | логина (placeholder отсутствует)               |
+---------------------------+---------------------------+------------------------------------------------+
| Войти                     | Ниже логина               | Кнопка для перехода на следующий экран         |
|                           |                           | авторизации (илл. «Авторизация, ввод пароля»)  |
+---------------------------+---------------------------+------------------------------------------------+
| Изменить параметры входа  | Ниже адреса               | Содержит лейбл "Логин" и поле для ввода        |
|                           |                           | логина (placeholder отсутствует)               |
+---------------------------+---------------------------+------------------------------------------------+
|                           | Самый низ экрана          | Фиксированная область для вывода ошибок        |
+---------------------------+---------------------------+------------------------------------------------+

В качестве *наименования системы* необходимо использовать 
значение, полученное при загрузке приложения. Поле присутствует 
только при наличии успешной авторизации ранее.

В качестве *адреса приложения* необходимо использовать значение 
поля "Адрес" из предыдущего экрана. При этом необходимо 
отображать только хост и порт (при наличии), очистив адрес от 
протокола, порта и концовки "/Synergy".

> Пример №1: для адреса приложения 
> 
> `https://synergy.arta.pro/Synergy`
> 
> в лейбле должно отображаться
> 
> `synergy.arta.pro`
> 
> Пример №2: для адреса приложения
> 
> `http://192.168.1.79:8080/Synergy`
> 
> в лейбле должно отображаться
> 
> `192.168.1.79`

В качестве *фотографии* должна использоваться фотография 
профиля ранее авторизованного пользователя. Если у данного 
пользователя отсутствует фото профиля, необходимо 
использовать стандартное изображение 
![](resources/img/autorise/elements/icon_user.png).

В качестве *ФИО* необходимо использовать значение фамилии и 
имени пользователя, полученное после успешной авторизации ранее. 

В качестве *логина пользователя* необходимо использовать 
значение поля "Логин" из предыдущего экрана.

В поле *"Пароль"* вводится пароль пользователя.

По нажатию на кнопку "Войти" проверяется введенная пара 
логин/пароль. Возможно исполнение альтернативных потоков 
событий 1 и 2. 

В случае успешной авторизации пользователь попадает на главную 
страницу модуля по умолчанию, указанного в 
[настройках приложения](#sec.settings). В результате успешной 
авторизации возможно исполнение альтернативного потока событий 
3.

Параметры авторизации должны записываться в менеджер аккаунтов 
на устройстве и при следующем входе в приложение авторизация 
должна происходить автоматически и в фоне.

> **Примечание**
> 
> Мобильный клиент не поддерживает одновременную авторизацию 
> двух и более пользователей на одном устройстве.

По нажатию на кнопку *"Изменить параметры входа"* необходимо 
очистить поле "Пароль" (независимо от его содержания) и 
возвращать [предыдущий экран авторизации](#sec.autorise.part1), 
в котором должны быть заполнены поля адреса и логина.

Если авторизация по введенному в предыдущем экране логину и 
адресу еще не проводилась проводилась, то экран с вводом пароля 
должен отображать следующую усеченную информацию.

+-----------------------------------------------------+------------------------+------------------------------------------------+
| Элемент управления                                  | Расположение на экране | Описание                                       |
+=====================================================+========================+================================================+
| synergy.company.com                                 | Вверху экрана          | Лейбл, обозначающий адрес приложения           |
+-----------------------------------------------------+------------------------+------------------------------------------------+
| ![](resources/img/autorise/elements/icon_user.png)\ | По центру экрана       | Стандартное изображение (заглушка фото)        |
+-----------------------------------------------------+------------------------+------------------------------------------------+
| l.abdreshen                                         | Под фотографией        | Лейбл, обозначающий логин пользователя         |
+-----------------------------------------------------+------------------------+------------------------------------------------+
| Пароль                                              | Ниже адреса            | Содержит лейбл "Логин" и поле для ввода        |
|                                                     |                        | логина (placeholder отсутствует)               |
+-----------------------------------------------------+------------------------+------------------------------------------------+
| Войти                                               | Ниже логина            | Кнопка для перехода на следующий экран         |
|                                                     |                        | авторизации (илл. «Авторизация, ввод пароля»)  |
+-----------------------------------------------------+------------------------+------------------------------------------------+
| Изменить параметры входа                            | Ниже адреса            | Содержит лейбл "Логин" и поле для ввода        |
|                                                     |                        | логина (placeholder отсутствует)               |
+-----------------------------------------------------+------------------------+------------------------------------------------+
|                                                     | Самый низ экрана       | Фиксированная область для вывода ошибок        |
+-----------------------------------------------------+------------------------+------------------------------------------------+

Логика данных полей не отличается от описанных выше.

***Альтернативные потоки событий.***

*Альтернативный поток 1. Не заполнено поле пароля.*

Действие не осуществляется, выходит ошибка:

`Введите пароль`

*Альтернативный поток 2. Некорректно введена пара логин/пароль.*

Действие не осуществляется, выходит ошибка:

`Неверный логин/пароль`

Ошибки из событий №1-2 должны выводиться в фиксированной области 
внизу экрана. Текст ошибки должен быть обрамлен в рамку красного 
цвета. Кроме того, соответствующее ошибке поле должно подсветиться 
красным цветом (илл. «Авторизация, вывод ошибки»).

*Альтернативный поток 3. Версия основного приложения Synergy ниже
требуемой (см. подробнее в ["Общие сведения"](#chapter_2)).*

Поверх открытого модуля выходит уведомление:

`Внимание! На сервере *имя_хоста* используется версия ARTA Synergy 
ниже *требуемая_версия*. Возможна нестабильная работа приложения.`

> **Примечание**
> 
> Метод API для получения настроек системы
> kz.arta.synergy.server.api.rest.common#getSettings
> 
> Метод API для получения ФИО пользователя
> kz.arta.synergy.server.api.rest.person#getUser
> 
> Сервлет для получения фотографии пользователя
> kz.arta.synergy.server.api.rest.person.UserPhotoServlet

