Общие сведения {#chapter_2}
==============

**Мобильный клиент должен предоставлять модули:**

-   Авторизация

-   Потоки работ

-   Документы

-   Файлы

-   Настройки приложения

**Общие требования:**

-   Для корректной работы мобильного приложения версия основного
    приложения Synergy на сервере должна быть не ниже 3.10.

-   Приложение должно поддерживать локализацию (казахский, русский и
    английский языки). По умолчанию берется значение текущей локали
    пользователя. В дальнейшем пользователь должен иметь возможность
    изменить локаль приложения в настройках приложения.

-   Во время выполнения запросов к серверу приложение должно отображать
    анимированное изображение.

-   Приложение должно предоставлять возможность шифрования канала
    передачи данных (SSL).

-   Приложение должно предоставлять возможность оффлайн-доступа с
    синхронизацией данных.

-   В случае, если подключение к локальному серверу (к которому 
    отсутствует настроенное подключение через интернет) происходит 
    не через локальную сеть (например, с мобильных данных), необходимо 
    не отображать никаких данных, выведя при этом сообщение-ошибку:
    
    `Отсутствует соединение с сервером`

Функционал, описанный в данной спецификации, должен быть реализован в
нативных приложениях для каждой из платформ. Считается, что
пользовательский интерфейс будет идентичен для всех платформ за
небольшими исключениями:

-   Так как у мобильных устройств на базе ОС Android есть системная
    кнопка "Назад", в пользовательском интерфейсе она должна
    отсутствовать.

> **Примечание**
> 
> На всех изображениях спецификации первая иллюстрация - для ОС Android,
> вторая - для iOS. На изображениях, где только одна иллюстрация -
> макеты совпадают для обеих ОС.

При загрузке приложения должны быть загружены следующие настройки,
которые далее будут использованы приложением:

-   наименование системы;

-   начало и завершение рабочего дня;

-   длительность рабочего дня (в часах);

-   список форм завершения;

-   разрешено ли ставить работы по резолюции, завершающиеся позже
    документа;

-   обязательно ли подписание документов перед отправкой;

-   отображать ли поле "автор" при создании работы;

-   разрешено ли добавлять соисполнителей к работам, не являющихся
    подчиненными;

-   разрешено ли передавать работы другим исполнителям;

-   ставить ли работы исполнителям от имени ответственного;

-   длительность на выполнение работ по умолчанию;

-   подпись поля "Отписано";

-   список приоритетов;

-   список диалогов создания;

-   доступные пункты меню (модуль "Потоки работ");

-   доступные пункты меню (модуль "Документы");

-   доступные пункты меню (модуль "Файлы");

-   названия кнопок действий с работой (согласование / утверждение /
    ознакомление / перепоручение / передача);

-   список типов работ для резолюций (по умолчанию: работа, 
    согласование, утверждение, ознакомление, резолюция, отправка 
    документа);

-   список типов работ для редактора маршрута (работа, согласование,
    утверждение, ознакомление, отправка документа, блокирующий процесс,
    регистрация, маршрут);

-   список пунктов создания документов, формы реестров которых имеют
    мобильное представление и которые доступны авторизованному
    пользователю;

-   маппинг прогрессов работ на текстовые значения;

-   подставлять ли дату завершения документа в пункты резолюции;

-   разрешено ли накладывать дополнительные резолюции;

-   отображать ли конечных пользователей на исполнении;

-   подписывать ли согласования, утверждения, ознакомления;

-   требовать ли ключ и сертификат.

