### Компонент для выбора записи адресной книги {#address_book_chooser}

Компонент формы "Ссылка на адресную книгу" позволяет 
добавлять на форму кликабельную ссылку на определенную 
запись адресной книги.

В режиме просмотра файла по форме является активной ссылкой, 
в режиме редактирования - поле с кнопкой, по нажатию которой 
открывается нативный экран «Адресная книга».

![Экран "Люди"](resources/img/forms/adress_book_chooser.png)

![Экран "Люди"](resources/img/forms/iOS/adress_book_chooser_ios.png)

![Экран "Организации"](resources/img/forms/adress_book_org_chooser.png)

![Экран "Организации"](resources/img/forms/iOS/adress_book_org_chooser_ios.png)

**Элементы управления экрана "Адресная книга".**

+---------------------------+------------------------+--------------------------------------------+
| Элемент управления        | Расположение на экране | Описание                                   |
+===========================+========================+============================================+
| "Люди" либо "Организации" | Верхняя панель         | Заголовок экрана, также является           |
|                           |                        | выпадающим списком                         |
+---------------------------+------------------------+--------------------------------------------+
| Поле поиска               | Вверху основной        | Поле ввода с плейсхолдером "Поиск записей" |
|                           | области                | и иконкой лупы справа                      |
+---------------------------+------------------------+--------------------------------------------+
| Панель со списком         | Вся основная область   | Плашки, отображающие информацию о          |
| контактов                 |                        | контактах адресной книги                   |
+---------------------------+------------------------+--------------------------------------------+
| Выбрать                   | Внизу                  | Кнопка                                     |
+---------------------------+------------------------+--------------------------------------------+

Поле поиска и кнопка "Выбрать" имеют фиксированное 
положение. В оставшейся области находится прокручиваемый 
список контактов.

По нажатию на *заголовок экрана* открывается стандартный 
[выпадающий список](#combobox) с двумя типами контактов:

*   `Люди` (выбран по умолчанию)
*   `Организации`

Отображаемый *список контактов* зависит от того, какой 
тип контактов необходимо отображать согласно значению 
заголовка экрана, и содержит:

*   для типа контактов "Люди":

    *   первый блок - %Фамилия% %Имя% %Отчество%;
    *   второй блок - %Организация%.

*   для типа контактов "Организации":

    *   первый блок - %Организация%;
    *   второй блок - %Адрес%.

> Примечание.
> 
> Для контактов типа "Люди" блок с организацией 
> отображает только первое значение в списке 
> организаций, указанных для данного контакта.

Невмещающиеся по ширине ФИО и названия переносятся на 
новую строку. Некоторые значения (например, отчества 
либо организации у "Людей" либо адрес у "Организаций") 
могут отсутствовать.

В список контактов попадают как общедоступные, так и 
личные контакты авторизованного пользователя. Данный 
список отображается с постепенной догрузкой. Изначально 
подгружается 30 контактов. При прокрутке пользователем 
вниз список дополняется новыми 30 контактами.

Между собой контакты в списке сортируются согласно их 
следованию в модуле "Адресная книга", а именно по 
возрастанию фамилии для "Людей" и названия для 
"Организаций". Изменять данную сортировку нельзя.

*Поведение экрана:*

*   Для выбора контакта необходимо нажать на строку, 
    вся строка выделится фоном.
    
*   Повторное нажатие на строку не снимает выделение.

*   При выделении контакта в списке, выделение 
    предыдущего элемента снимается.

*Поиск записей* осуществляется по всем контактам 
выбранного типа и только начиная с 4-го символа в 
поисковом запросе. Поиск является "живым" и производится 
по всем отображаемым полям плашки, его результаты 
фильтруют отображаемый список. При вводе текста иконка 
лупы заменяется на иконку крестика. Очистить поле ввода 
можно, нажав на крестик (крестик заменяется на иконку 
лупы). Пустой запрос поиска - отображается список со 
всеми контактами.

При смене типа контакта (люди/организации) поле поиска 
очищается.

Если пользователь на экране "Адресная книга" нажимает 
на *кнопку "Назад"*, мобильный клиент возвращает 
пользователя в [проигрыватель форм](#forms_view) в том 
состоянии, которое было у компонента до вызова данного 
экрана.

После выделения записи списка пользователь нажимает на 
*кнопку «Выбрать»*. Действие выполняется, только если 
выделен какой-либо контакт, иначе необходимо выдавать 
сообщение:

`Запись не выбрана`

и не выполнять действие.

В результате же успешного выполнения действия мобильный 
клиент также возвращает пользователя в 
[проигрыватель форм](#forms_view), в поле компонента 
отображается выбранный элемент списка.

*Проигрыватель форм. Переход по ссылкам.*

По нажатию на ссылку выводится сообщение о 
невозможности ее открытия:

`В мобильной версии просмотр адресной книги не 
поддерживается`

Ссылка не открывается.

