### Окно сортировки записей реестра {#sec.registries_sort}

По нажатию на кнопку "Сортировка" открывается меню 
`Сортировать по полю` (для ОС Android) либо `Сортировать` 
(для iOS). Внешний вид меню - системный, с доработками.

В построении меню участвуют те столбцы реестра, которые 
удовлетворяют следующим требованиям.

*   Во-первых, в меню попадают только те столбцы, 
    по которым возможна сортировка, т.е. сюда не 
    должны входить столбцы на основе компонентов:

    *   Таблица (статическая, динамическая)
    *   Страница
    *   Неизменяемый текст
    *   Выбор вариантов
    *   Изображение
    *   Файл
    *   Лист подписей
    *   Ход выполнения
    *   Ссылка на документ
    *   Свойства документа
    *   Ссылка на файл в хранилище
    
    Кроме того, компоненты внутри статической таблицы 
    сюда попадают, а внутри динамической - нет.

*   Во-вторых, в меню попадают только те столбцы, 
    которые отображаются в плашке на момент открытия 
    окна. Т.е. для "краткого" вида - это только те 
    отображаемые столбцы, помеченные как значащее 
    содержимое, а для "полного" - уже все отображаемые 
    столбцы. В обоих случаях - с учетом пункта выше.

Пункты меню отсортированы в порядке следования 
соответствующих столбцов в настройках реестра.

Если название пункта меню полностью не помещается на 
строке, с правого края оно должно быть обрезано с 
добавлением многоточие. Если количество отображаемых 
пунктов меню больше высоты экрана, появляется 
вертикальный скролл на все меню, исключая «шапку» 
(т.е. список должен уходить под «шапку»).

*Для ОС Android.*

Окно разделено на заголовок, содержимое с пунктами и 
нижними кнопками "Отмена" и "Принять". Пункты в данном 
случае есть столбцы реестра (с учетом требований выше).

При открытии окна справа от пункта, по которому 
отсортирован список записей в данный момент, 
отображается иконка направления сортировки. При 
первом открытии иконка отсутствует вовсе.

Поведение окна "Сортировать по полю":

*   Для выбора пункта необходимо нажать на строку либо 
    иконку, справа отобразится иконка направления 
    сортировки:

    *   по убыванию (по умолчанию): 
        ![](resources/img/forms/elements/sort_down.png)

    *   по возрастанию: 
        ![](resources/img/forms/elements/sort_up.png)

*   Повторное нажатие на строку меняет направление 
    сортировки на противоположное.

*   При выделении пункта, выделение предыдущего пункта 
    снимается.

Кнопка "Сортировка" может быть в одном из следующих видов:

*   сортировка, настроенная в реестре (отображается 
    по умолчанию при первом входе в компонент и пока 
    не изменили сортировку): 
    ![](resources/img/forms/elements/sort.png)

*   сортировка по убыванию, настроенная в данном экране: 
    ![](resources/img/forms/elements/sort_desc.png)

*   сортировка по возрастанию, настроенная в данном экране: 
    ![](resources/img/forms/elements/sort_asc.png)

![Сортировка в ОС Android, начало списка](resources/img/forms/register_chooser_sort_1.png)

![Сортировка в ОС Android, середина списка](resources/img/forms/register_chooser_sort_2.png)

![Сортировка в ОС Android, конец списка](resources/img/forms/register_chooser_sort_3.png)

*Для iOS.*

Окно разделено на заголовок с кнопками "Отмена" и 
"Принять", а также содержимое со столбцами реестра 
(с учетом требований выше).

При открытии окна справа от пункта, по которому 
отсортирован список записей в данный момент, 
отображается иконка направления сортировки. При 
первом открытии иконка отсутствует вовсе.

Поведение окна "Сортировать":

*   Для выбора пункта необходимо нажать на строку либо 
    иконку, справа отобразится иконка направления 
    сортировки:

    *   по убыванию (по умолчанию): 
        ![](resources/img/forms/elements/sort_down.png)

    *   по возрастанию: 
        ![](resources/img/forms/elements/sort_up.png)

*   Повторное нажатие на строку меняет направление 
    сортировки на противоположное.

*   При выделении пункта, выделение предыдущего пункта 
    снимается.

![Сортировка в iОS](resources/img/forms/iOS/register_chooser_sort_ios.png)

*Для обеих ОС.*

После выбора пункта меню и направления сортировки 
необходимо нажать на кнопку подтверждения действия 
"Принять". Если выбор пункта отсутствует, то действие 
должно быть аналогично "Отмене".

Для того, чтобы отменить действие и закрыть окно, 
необходимо нажать на кнопку "Отмена" либо в пустой 
области экрана, дополнительно для ОС Android - с 
помощью кнопки "Назад".


