#### Создание папки хранилища {#sec.offline_create_folder}

Исходное поведение [здесь](#sec.files_create).

В режиме оффлайн доступен пункт создания новой папки хранилища, 
при наличии, в меню создания (`new_folder`). Валидация на пустое, 
некорректное либо совпадающее название папки должно производиться 
в момент выполнения действия (а не синхронизации). Необходимо 
фиксировать время создания папки на устройстве. Создание 
папки на сервере должно происходить по следующему алгоритму.

1.  Если на стороне сервера отсутствует доступ к добавлению папки 
    в указанную папку (отсутствует право «Добавление нового 
    элемента» / `ADD`), то действие не выполнять. В журнал 
    синхронизации при этом должна произойти запись в формате:

    -   условно успешная синхронизация:

        `Новая папка "название_папки" в папку "название_папки" 
        не добавлена: Недостаточно прав для выполнения действия`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

    -   неуспешная синхронизация:

        `Новая папка "название_папки" в папку "название_папки": 
        ошибка синхронизации`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

2.  Если на стороне сервера имеется доступ, но в указанной папке 
    существует дочерняя папка с таким названием, то действие 
    выполнять частично: папка должна создаться с обновленным 
    названием *'исходное-имя-папки_ГГГГ-ММ-ДД ЧЧ_ММ'*. В журнал 
    синхронизации при этом должна произойти запись в формате:

    -   условно успешная синхронизация:

        `Новая папка "итоговое_название_папки" в папку 
        "название_папки" добавлена`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

    -   неуспешная синхронизация:

        `Новая папка "итоговое_название_папки" в папку 
        "название_папки": ошибка синхронизации`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

3.  Во всех остальных случаях действие создания новой папки 
    должно всегда выполняться:

    -   необходимо фиксировать время создания на сервере;

    -   в качестве времени создания папки считать время 
        применения действия на сервере;

    -   в журнал синхронизации при применении должна произойти 
        запись в формате:

        -   успешная синхронизация:

            `Новая папка "итоговое_название_папки" в папку 
            "название_папки" добавлена`

            `ГГГГ-ММ-ДД ЧЧ:ММ`

        -   неуспешная синхронизация:

            `Новая папка "итоговое_название_папки" в папку 
            "название_папки": ошибка синхронизации`

            `ГГГГ-ММ-ДД ЧЧ:ММ`

