#### Удаление элемента хранилища {#sec.offline_delete_element}

Исходное поведение [здесь](#sec.files_delete).

В режиме оффлайн доступен пункт удаления папки / файла хранилища, 
в контекстном меню самого элемента. Необходимо фиксировать время 
удаления элемента на устройстве. Удаление на сервере должно 
происходить по следующему алгоритму.

*Для элемента - папки.*

1.  Если на стороне сервера отсутствует доступ на удаление 
    папки в указанной папке (отсутствует право «Удаление 
    элемента» / `DELETE`), то действие не выполнять. В журнал 
    синхронизации при этом должна произойти запись в формате:

    -   условно успешная синхронизация:

        `Папка "название_папки" не удалена: Недостаточно прав 
        для выполнения действия`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

    -   неуспешная синхронизация:

        `Удаление папки "название_папки": ошибка синхронизации`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

2.  Во всех остальных случаях действие удаления папки должно 
    всегда выполняться:

    -   необходимо фиксировать время удаления на сервере;

    -   в качестве времени удаления папки считать время 
        применения действия на сервере;

    -   в журнал синхронизации при применении должна произойти 
        запись в формате:

        -   успешная синхронизация:

            `Удаление папки "название_папки" синхронизировано`

            `ГГГГ-ММ-ДД ЧЧ:ММ`

        -   неуспешная синхронизация:

            `Удаление папки "название_папки": ошибка 
            синхронизации`

            `ГГГГ-ММ-ДД ЧЧ:ММ`

*Для элемента - файла.*

1.  Если на стороне сервера отсутствует доступ на удаление 
    файла в указанной папке (отсутствует право «Удаление 
    элемента» / `DELETE`), то действие не выполнять. В журнал 
    синхронизации при этом должна произойти запись в формате:

    -   условно успешная синхронизация:

        `Файл "название_файла.расширение" не удален: 
        Недостаточно прав для выполнения действия`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

    -   неуспешная синхронизация:

        `Удаление файла "название_файла.расширение": ошибка 
        синхронизации`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

2.  Во всех остальных случаях действие удаления файла должно 
    всегда выполняться:

    -   необходимо фиксировать время удаления на сервере;

    -   в качестве времени удаления файла считать время 
        применения действия на сервере;

    -   в журнал синхронизации при применении должна произойти 
        запись в формате:

        -   успешная синхронизация:

            `Удаление файла "название_файла.расширение" 
            синхронизировано`

            `ГГГГ-ММ-ДД ЧЧ:ММ`

        -   неуспешная синхронизация:

            `Удаление файла "название_файла.расширение": 
            ошибка синхронизации`

            `ГГГГ-ММ-ДД ЧЧ:ММ`

