#### Перемещение элемента хранилища {#sec.offline_move_element}

Исходное поведение [здесь](#sec.files_move).

В режиме оффлайн доступен пункт меню "Переместить" папки / файла 
хранилища, в контекстном меню самого элемента. Валидация на 
совпадающий элемент в папке месторасположения должно производиться 
в момент выполнения действия (а не синхронизации). Необходимо 
фиксировать время перемещения на устройстве. Перемещение элемента 
на сервере должно происходить по следующему алгоритму.

*Для элемента - папки.*

1.  Если на стороне сервера отсутствует доступ для перемещения 
    папки в исходной папке (отсутствует право «Переименование / 
    Перемещение элемента» / `MOVE`), и/или доступ для добавления 
    новой папки в папку месторасположения (отсутствует право 
    «Добавление нового элемента» / `ADD`), то действие не выполнять. 
    В журнал синхронизации при этом должна произойти запись в 
    формате:

    -   условно успешная синхронизация:

        `Перемещение папки "название_папки" не синхронизировано: 
        Недостаточно прав для выполнения действия`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

    -   неуспешная синхронизация:

        `Перемещение папки "итоговое_название_папки": 
        ошибка синхронизации`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

2.  Если на стороне сервера имеется доступ, но при этом в папке 
    месторасположения существует дочерняя с совпадающим названием 
    перемещаемой папки, то действие выполнять частично: папка 
    должна добавиться с обновленным названием 
    *'переименованное-имя-папки_ГГГГ-ММ-ДД ЧЧ_ММ'*. В журнал 
    синхронизации при этом должна произойти запись в формате:

    -   условно успешная синхронизация:

        `Папка "итоговое_название_папки" перемещена в 
        "папка_месторасположения"`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

    -   неуспешная синхронизация:

        `Перемещение папки "итоговое_название_папки": ошибка 
        синхронизации`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

3.  Во всех остальных случаях действие перемещения папки 
    должно всегда выполняться:

    -   необходимо фиксировать время перемещения на сервере;

    -   в качестве времени перемещения папки считать время 
        применения действия на сервере;

    -   в журнал синхронизации при применении должна произойти 
        запись в формате:

        -   успешная синхронизация:

            `Папка "название_папки" перемещена в 
            "папка_месторасположения"`

            `ГГГГ-ММ-ДД ЧЧ:ММ`

        -   неуспешная синхронизация:

            `Перемещение папки "название_папки": ошибка 
            синхронизации`

            `ГГГГ-ММ-ДД ЧЧ:ММ`

*Для элемента - файла.*

1.  Если на стороне сервера отсутствует доступ для перемещения 
    файла в исходной папке (отсутствует право «Переименование / 
    Перемещение элемента» / `MOVE`), и/или доступ для добавления 
    нового файла в папку месторасположения (отсутствует право 
    «Добавление нового элемента» / `ADD`), то действие не выполнять. 
    В журнал синхронизации при этом должна произойти запись в 
    формате:

    -   условно успешная синхронизация:

        `Перемещение файла "название_файла.расширение" не 
        синхронизировано: Недостаточно прав для выполнения 
        действия`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

    -   неуспешная синхронизация:

        `Перемещение файла "название_файла.расширение": ошибка 
        синхронизации`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

2.  Если на стороне сервера имеется доступ, но при этом в папке 
    месторасположения существует файл с совпадающим названием 
    перемещаемого файла, то действие выполнять частично: 
    файл должен добавиться с обновленным названием 
    *'переименованное-имя-файла_ГГГГ-ММ-ДД ЧЧ_ММ.расширение'*. 
    В журнал синхронизации при этом должна произойти запись в 
    формате:

    -   условно успешная синхронизация:

        `Файл "итоговое_название_файла.расширение" перемещен в 
        "папка_месторасположения"`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

    -   неуспешная синхронизация:

        `Перемещение файла "итоговое_название_файла.расширение": 
        ошибка синхронизации`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

3.  Во всех остальных случаях действие перемещения файла 
    должно всегда выполняться:

    -   необходимо фиксировать время перемещения на сервере;

    -   в качестве времени перемещения файла считать время 
        применения действия на сервере;

    -   в журнал синхронизации при применении должна произойти 
        запись в формате:

        -   успешная синхронизация:

            `Файл "название_файла.расширение" перемещен в 
            "папка_месторасположения"`

            `ГГГГ-ММ-ДД ЧЧ:ММ`

        -   неуспешная синхронизация:

            `Перемещение файла 
            "итоговое_название_файла.расширение": ошибка 
            синхронизации`

            `ГГГГ-ММ-ДД ЧЧ:ММ`
            
            