#### Переименование элемента хранилища {#sec.offline_rename_element}

Исходное поведение [здесь](#sec.files_rename).

В режиме оффлайн доступен пункт меню "Переименовать" папки / 
файла хранилища, в контекстном меню самого элемента. Валидация 
на пустое, некорректное либо совпадающее название элемента 
должно производиться в момент выполнения действия (а не 
синхронизации). Необходимо фиксировать время переименования 
на устройстве. Переименование элемента на сервере должно 
происходить по следующему алгоритму.

*Для элемента - папки.*

1.  Если на стороне сервера отсутствует доступ для переименования 
    папки в указанной папке (отсутствует право «Переименование / 
    Перемещение элемента» / `MOVE`), то действие не выполнять. В 
    журнал синхронизации при этом должна произойти запись в 
    формате:

    -   условно успешная синхронизация:

        `Переименование папки "итоговое_название_папки" не 
        синхронизировано: Недостаточно прав для выполнения 
        действия`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

    -   неуспешная синхронизация:

        `Переименование папки "итоговое_название_папки": 
        ошибка синхронизации`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

2.  Если на стороне сервера имеется доступ, но при этом в 
    родительской папке существует дочерняя с совпадающим 
    названием переименованной папки, то действие выполнять 
    частично: папка должна добавиться с обновленным названием 
    *'переименованное-имя-папки_ГГГГ-ММ-ДД ЧЧ_ММ'*. В журнал 
    синхронизации при этом должна произойти запись в формате:

    -   условно успешная синхронизация:

        `Переименование папки синхронизировано, новое значение: 
        "итоговое_название_папки"`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

    -   неуспешная синхронизация:

        `Переименование папки "итоговое_название_папки": ошибка 
        синхронизации`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

3.  Во всех остальных случаях действие переименование папки 
    должно всегда выполняться:

    -   необходимо фиксировать время переименования на сервере;

    -   изменение названия папки хранилища должно примениться, 
        даже если название на сервере не совпадает с исходным 
        названием в оффлайне;

    -   в качестве времени переименования папки считать время 
        применения действия на сервере;

    -   в журнал синхронизации при применении должна произойти 
        запись в формате:

        -   успешная синхронизация:

            `Переименование папки синхронизировано, новое 
            значение: "итоговое_название_папки"`

            `ГГГГ-ММ-ДД ЧЧ:ММ`

        -   неуспешная синхронизация:

            `Переименование папки "итоговое_название_папки": 
            ошибка синхронизации`

            `ГГГГ-ММ-ДД ЧЧ:ММ`

*Для элемента - файла.*

1.  Если на стороне сервера отсутствует доступ для переименования 
    файла в указанной папке (отсутствует право «Переименование / 
    Перемещение элемента» / `MOVE`), то действие не выполнять. В 
    журнал синхронизации при этом должна произойти запись в 
    формате:

    -   условно успешная синхронизация:

        `Переименование файла "итоговое_название_файла.расширение" 
        не синхронизировано: Недостаточно прав для выполнения 
        действия`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

    -   неуспешная синхронизация:

        `Переименование файла "итоговое_название_файла.расширение": 
        ошибка синхронизации`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

2.  Если на стороне сервера имеется доступ, но при этом в 
    родительской папке существует файл с совпадающим названием 
    переименованного файла, то действие выполнять частично: 
    файл должен добавиться с обновленным названием 
    *'переименованное-имя-файла_ГГГГ-ММ-ДД ЧЧ_ММ.расширение'*. 
    В журнал синхронизации при этом должна произойти запись в 
    формате:

    -   условно успешная синхронизация:

        `Переименование файла синхронизировано, новое значение: 
        "итоговое_название_файла.расширение"`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

    -   неуспешная синхронизация:

        `Переименование файла "итоговое_название_файла.расширение": 
        ошибка синхронизации`

        `ГГГГ-ММ-ДД ЧЧ:ММ`

3.  Во всех остальных случаях действие переименование файла 
    должно всегда выполняться:

    -   необходимо фиксировать время переименования на сервере;

    -   изменение названия файла хранилища должно примениться, 
        даже если название на сервере не совпадает с исходным 
        названием в оффлайне;

    -   в качестве времени переименования файла считать время 
        применения действия на сервере;

    -   в журнал синхронизации при применении должна произойти 
        запись в формате:

        -   успешная синхронизация:

            `Переименование файла синхронизировано, новое 
            значение: "итоговое_название_файла.расширение"`

            `ГГГГ-ММ-ДД ЧЧ:ММ`

        -   неуспешная синхронизация:

            `Переименование файла 
            "итоговое_название_файла.расширение": ошибка 
            синхронизации`

            `ГГГГ-ММ-ДД ЧЧ:ММ`

