Фильтры потоков работ {#sec.workflow_filters}
---------------------

По нажатию на кнопку "Фильтры", а также проведя пальцем от левой стороны экрана 
со списком работ к правой, раскрывается левая панель навигатора фильтров 
(илл. «Фильтры работ»).

![Фильтры работ](resources/img/workflow/filters.png)

Верхняя панель содержит кнопку "Настройки" ([Настройки приложения](#sec.settings)) 
и надпись "Навигатор". Нижняя панель отображается только для включенного флажка 
"Синхронизировать данные для оффлайн-работы" и содержит кнопку синхронизации.

Кнопка синхронизации содержит иконку и один из вариантов подписи к ней:

*   `Синхронизация не производилась` - для варианта, когда на устройстве 
    отсутствуют данные синхронизации;

*   `Идёт синхронизация` - для активного процесса синхронизации (см. подробнее 
    в [Оффлайн-работа с приложением](#sec.offline));

*   `Последняя синхронизация: %ДД месяц ЧЧ:ММ%` - во всех остальных случаях 
    (указывается дата и время последней успешной синхронизации).

Параметры фильтров:

+--------------------------------------+-------------+
| Параметр                             | Поле API    |
+======================================+=============+
| Название фильтра                     | name        |
+--------------------------------------+-------------+
| Тип фильтра                          | filterType  |
+--------------------------------------+-------------+
| Количество документов внутри фильтра | count       |
+--------------------------------------+-------------+
| Наличие дочерних фильтров            | hasChildren |
+--------------------------------------+-------------+

При каждом новом запуске приложения, а также после переключения модулей все 
основные фильтры должны быть свернуты, а выделенным являться первый фильтр 
навигатора. В остальных случаях развернутость дерева и последний выделенный 
фильтр должны сохранять свои значения.

Если фильтр содержит вложенные фильтры, то в правой части отображается иконка 
![](resources/img/workflow/elements/filters_undetailed.png) для свернутого 
фильтра и ![](resources/img/workflow/elements/filters_detailed.png) для 
развернутого. По нажатию на квадратную область (илл. «Фильтры») вокруг иконки 
свернутого фильтра он разворачивается, и наоборот. Одновременно не может быть 
раскрыто более одного фильтра. В этом случае предыдущий развернутый фильтр 
сворачивается.

Справа от названия каждого из фильтров и вложенных подфильтров "На исполнении" 
и "На контроле" в скобках указывается счетчик в формате `(N1/N2)`, где N1 - 
количество непросмотренных уведомлений, N2 - общее количество работ в данном 
фильтре. При отсутствии значения N1 формат отображения счетчика - `(N2)`, 
при отсутствии работ в фильтре счетчик не отображается вовсе.

Если название фильтра (с счетчиком) полностью не помещается на плашке, с 
правого края оно должно быть затемнено градиентом из прозрачного в цвет фона.

По нажатию на название фильтра левая панель скрывается и пользователю 
отображается список работ согласно выбранного фильтра. Также панель можно 
скрыть тремя способами:

1.  проведя пальцем от правой стороны экрана к левой;
2.  нажав по любому месту правой стороны экрана (там, где отображается часть 
    экрана списка работ);
3.  нажав на кнопку "Назад".

> **Примечание**
>
> API для получения фильтров описан в javadoc:
>
> kz.arta.synergy.server.api.rest.works#getFilters.
>
> API для получения счетчиков фильтров:
>
> kz.arta.synergy.server.api.rest.works#getCounters


