###### Форма завершения - форма {#sec.workflow_work_end_with_forma_form}

Внешний вид экрана зависит от того, есть ли подтвержденные 
результаты дочерних работ или нет. Для того, чтобы это узнать, 
необходимо вызвать метод API

`kz.arta.synergy.server.api.rest.works#getWorkCompletionData`

Если список `previous_results` не пустой - значит существуют 
подтвержденные результаты дочерних работ, иначе - не 
существуют.

Метод API для выставления результата один и тот же как для 
работ, у которых есть результат дочерних работ, так и для 
тех, у которых нет:

`kz.arta.synergy.server.api.rest.works#setWorkResult`.

**Завершение работы, у которой нет результатов дочерних работ.**

Пользователь выставляет 100% прогресса либо нажимает на 
кнопку "Завершить". Открывается экран 
[проигрывателя формы](#forms_view) для заполнения файла по 
форме. Экран, по сравнению со стандартным проигрывателем, 
урезан:

*   отсутствует иконка "Сохранить", основное действие по 
    кнопке "Готово";
*   в меню отсутствуют пункты переключения в режим 
    просмотра, скачивания и просмотра информации, т.е. 
    доступно только переключение между мобильным 
    представлением и основным в режиме редактирования.

>   **Примечание**
> 
>   В версиях мобильного приложения 3.6 и ниже после того, 
>   как пользователь выставляет 100% прогресса либо нажимает 
>   на кнопку "Завершить", необходимо вызвать метод API
>   rest/api/asforms/form/{formID}. Если значение параметра 
>   **isMobile** = false, то выдавать сообщение-ошибку:
> 
>   `Действие не может быть выполнено, т.к. форма не имеет
>   мобильного представления`
> 
>   и не выполнять действие. Если **isMobile** = true, то 
>   необходимо открывать экран "Результат" для заполнения
>   файла по форме в мобильном представлении ([Проигрыватель формы](#forms_view)).

Чтобы получить форму, необходимо вызвать метод API 
`rest/api/asforms/form/{formID}`, чтобы получить данные 
формы - `rest/api/asforms/data/{formID}`.

>   **Примечание**
> 
>   В версиях мобильного приложения 3.6 и ниже 
>   мобильное представление поддерживает только 4 компонента
>   (лейбл, однострочное и мнострочное поле, выпадающий	 
>   список), все они должны отрисовываться как стандартные
>   компоненты в любом другом экране приложения. Кнопка 
>   "Готово" имеет фиксированное положение, вся остальная 
>   область экрана прокручиваема.

Если пользователь нажимает на кнопку "Назад", возвращается 
экран информации о работе в том же состоянии, что и до 
завершения работы.

Если пользователь нажимает на кнопку "Готово", данные по 
форме должны сохраниться в отдельный файл в "Прочих". Имя 
такого файла должно быть составлено по формату

`%Название формы% - %Фамилия И.О. сохранившего%`

Мобильный клиент возвращает пользователя к экрану 
информации о работе, информация обновляется.

**Завершение работы, у которой есть результаты дочерних работ.**

Пользователь выставляет 100% прогресса либо нажимает на 
кнопку "Завершить". Открывается экран "Результат" для 
выбора либо заполнения файла по форме.

>   **Примечание**
> 
>   В версиях мобильного приложения 3.6 и ниже после того, как
>   пользователь  выставляет 100% прогресса либо нажимает на 
>   кнопку "Завершить", необходимо вызвать метод API
>   rest/api/asforms/form/{formID}. Если значение параметра 
>   **isMobile** = false, то выдавать сообщение-ошибку 
>   "Действие не может быть выполнено, т.к. форма не имеет
>   мобильного представления" и не выполнять действие.	 
>   Если **isMobile** = true, то необходимо открывать экран
>   "Результат" для	 выбора/заполнения файла по форме в 
>   мобильном представлении ([Проигрыватель формы](#forms_view)).

![Завершение работы, у которой есть результаты дочерних работ (форма завершения - форма)](resources/img/workflow/work_result_form2.png)

![Завершение работы, у которой есть результаты дочерних работ (форма завершения - форма)](resources/img/workflow/iOS/work_result_form2_ios.png)

Кнопка "Готово" имеет фиксированное положение, вся 
остальная область экрана (панели "Перепорученные" и 
"Результат работы") прокручиваемы.

Результат работы может быть выбран из результатов 
дочерних работ: в таком случае на сервер должен быть 
передан идентификатор результата дочерней работы.

Для этого пользователю необходимо на панели 
"Перепорученные" нажать на один из результатов, при 
этом выбранный результат отмечается в списке фоном, 
его название копируется в поле «Результат работы». 
При долгом нажатии (долгий tap) по результату работы 
открывается [проигрыватель формы](#forms_view) только 
для просмотра файла по форме. Экран, по сравнению со 
стандартным проигрывателем, урезан:

*   отсутствует иконка "Сохранить", основное действие по 
    кнопке "Готово";
*   в меню отсутствуют пункты переключения в режим 
    редактирования, скачивания и просмотра информации, 
    т.е. доступно только переключение между мобильным 
    представлением и основным в режиме просмотра.

Кроме того, пользователь может создать новый результат 
работы, используя кнопку "+" на верхней панели. По ее 
нажатию открывается экран [проигрывателя формы](#forms_view) 
для заполнения файла по форме. Экран, по сравнению со 
стандартным проигрывателем, урезан:

*   отсутствует иконка "Сохранить", основное действие по 
    кнопке "Готово";
*   в меню отсутствуют пункты переключения в режим 
    просмотра, скачивания и просмотра информации, т.е. 
    доступно только переключение между мобильным 
    представлением и основным в режиме редактирования.

>   **Примечание**
> 
>   В версиях мобильного приложения 3.6 и ниже после выбора
>   пользователем на панели "Перепорученные" одного из 
>   результатов, выбранный результат отмечается в списке 
>   фоном и в панели "Результат работы" отображается данные
>   файла по форме.

>   ![Завершение работы, у которой есть результаты дочерних работ (форма завершения - форма) для версий 3.6 и ниже](resources/img/workflow/work_result_form2_36.png)

>   ![Завершение работы, у которой есть результаты дочерних работ (форма завершения - форма) для версий 3.6 и ниже](resources/img/workflow/iOS/work_result_form2_ios_36.png)


>   По нажатию на кнопку "Готово" :
> 
>   -   если пользователь вносил изменения в панели "Результат
>       работы:", то данные по форме должны сохраниться в 
>       отдельный файл в "Прочих", имя такого файла должно быть
>       составлено по формату "%Название формы% - %Фамилия И.О. 
>       сохранившего%";
>       
>   -   если пользователь ничего не изменял в выбранном из 
>       перепорученных	файле по форме, то результатом данной 
>       работы необходимо считать тот выбранный файл по форме.

Если пользователь нажимает на кнопку "Назад", 
возвращается экран информации о работе в том же 
состоянии, что и до завершения работы.

Если пользователь нажимает на кнопку «Готово», но файл 
результата не задан, приложение должно отобразить 
сообщение:

`Выберите результат работы`

и не выполнять действие.

Если пользователь нажимает на кнопку «Готово», мобильный 
клиент возвращает пользователя к экрану информации о 
работе, информация обновляется. 



